//****************************************************************************
//	aisa06w.pas
//
//	aISA-A06W/H
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/12
//
//****************************************************************************

unit aisa06w;

interface

uses
	Windows;

const
{ őXbg }
	AISA06_MAX_SLOTS = 16;

{ _Xbgw }
	AISA06_SLOT_AUTO = $ffff;

{ `l }
	AISA06_CH_1 = 0;
	AISA06_CH_2 = 1;
	AISA06_CH_3 = 2;
	AISA06_CH_4 = 3;

{ G[R[h̒` }
	AISA06_ERR_INTERNAL		 = 5100; { Send mail to us }
	AISA06_ERR_UNKNOWN		 = 5101; { Help me! }
	AISA06_SUCCESS				 = 0;		 { I }
	AISA06_ERR_NO_DEVICE	 = 5000; { No device or not an aISA-A15 }
	AISA06_ERR_RESOURCE		 = 5001; { Resource exhaustion }
	AISA06_ERR_INVALID_ARG = 5002; { Invalid argument(s) }
	AISA06_ERR_SLOT				 = 5003; { _Xbgԍsłi܂͌܂j}
	AISA06_ERR_CHANNEL		 = 5004; { `lw肪sł }
	AISA06_ERR_NOT_CREATED = 5005; { foCXNGCgĂ܂ }
	AISA06_ERR_TIMEOUT		 = 5006; { f[^o͂Ɏs܂ }

{ I/O\[XzE }
	AISA06_NMAX_MEM =	9;	{ MAX_MEM_REGISTERS }
	AISA06_NMAX_IO	= 20; { MAX_IO_PORTS }
	AISA06_NMAX_IRQ	= 7;	{ MAX_IRQS }
	AISA06_NMAX_DMA	= 7;	{ MAX_DMA_CHANNELS }

{ ***** I/O\[X\ ***** }
{ YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B}
type
	TAISA06RESOURCE_NT = record
		dwIOPortBase:		DWord;		{ I/O|[gJnAhX }
		dwIOPortLength: DWord;		{ I/O|[g }
	end;

PAISA06RESOURCE_NT = ^TAISA06RESOURCE_NT;

const
	AISA06_MAX_CH_W = 4;		{ aISA-A06W̃`l }
	AISA06_MAX_CH_H = 2;		{ aISA-A06H̃`l }

const
	AISA06_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA06_DLL_NAME = 'aisa06.dll';		{ DLL }

function Aisa06wDllOpen: Boolean;		{ DLL [h }
function Aisa06wDllClose: Boolean;	{ DLL A[h }



{ aISA-A06W/H DLL,Driver̃o[Wԍ擾 }
function Aisa06wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-A06W/H̎gp錾 }
function Aisa06wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ CӂaISA-A06W/H̎gpJ }
function Aisa06wClose(wLogSlot: Word): Boolean;


{ \[X擾 }
function Aisa06wGetResource(wLogSlot: Word; pResInfo: PAISA06RESOURCE_NT): Boolean;


{ o̓f[^̐ݒ }
function Aisa06wSetData(wLogSlot: Word; wChData: Word; wDaData: Word): Boolean;

{ O͏Ԃ̎擾 }
function Aisa06wGetCH(wLogSlot: Word; var pdwCH1: DWord; var pdwCH2: DWord): Boolean;


{ aISA-A06W/H̃G[R[h }
function Aisa06wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa06Create = function(var pwLogSlot: WORD; hWnd: THandle; uWMBase: UInt;	var pvInitArg): Bool; stdcall;
	TAisa06Close = function(wLogSlot: Word): Bool; stdcall;
	TAisa06GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa06GetResource = function(wLogSlot: Word; pres: PAISA06RESOURCE_NT): Bool; stdcall;
	TAisa06SetData = function(wLogSlot: Word; wChData: Word; wDaData: Word): Bool; stdcall;
	TAisa06GetLastError = function(wLogSlot: Word): DWord; stdcall;
	TAisa06GetCH = function(wLogSlot: Word; var	pdwCH1: DWord; var pdwCH2: DWord): Bool; stdcall;

function Aisa06wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa06GetVersion: TAisa06GetVersion;
	pAisa06Create: TAisa06Create;
	pAisa06Close: TAisa06Close;
	pAisa06GetResource: TAisa06GetResource;
	pAisa06SetData: TAisa06SetData;
	pAisa06GetCH: TAisa06GetCH;
	pAisa06GetLastError: TAisa06GetLastError;


//****************************************************************************
// 		aisa06.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA06_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa06wGetDllExportFunc = False then
	begin
		Aisa06wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa06.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aISA-A06W/H DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa06GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-A06W/H̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[AhX
//				hWnd		bZ[W󂯎EBhEnh
//				uWMBase	bZ[WID̊l
//				pvInitArg ̂߂̗\
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa06Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		aISA-A06W/H̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa06Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pResInfo \[Xi[\̂̃AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wGetResource(wLogSlot: Word; pResInfo: PAISA06RESOURCE_NT): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa06GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// 		o̓f[^̐ݒ
// 		wLogSlot _Xbg
//				wChData	 ݃`l(0 ` 3)
//				wDaData	 D/A݃f[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wSetData(wLogSlot: Word; wChData: Word; wDaData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa06SetData(wLogSlot, wChData, wDaData);
end;

//****************************************************************************
// 		O͏Ԃ̎擾
// 		wLogSlot _Xbg
//				pdwCH1	 CH1̏
//				pdwCH2	 CH2̏
// ߂l  True
//				s False
//****************************************************************************
function Aisa06wGetCH(wLogSlot: Word; var pdwCH1: DWord; var pdwCH2: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa06GetCH(wLogSlot, pdwCH1, pdwCH2);
end;

//****************************************************************************
// 		aISA-A06W/H̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa06wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA06_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa06GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa06wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa06GetVersion ̃AhX擾
	pAisa06GetVersion := GetProcAddress(hDLL, 'Aisa06GetVersion');
	if @pAisa06GetVersion = nil then Exit;

	// Aisa06Create ̃AhX擾
	pAisa06Create := GetProcAddress(hDLL, 'Aisa06Create');
	if @pAisa06Create = nil then Exit;

	// Aisa06Close ̃AhX擾
	pAisa06Close := GetProcAddress(hDLL, 'Aisa06Close');
	if @pAisa06Close = nil then Exit;

	// Aisa06GetResource ̃AhX擾
	pAisa06GetResource := GetProcAddress(hDLL, 'Aisa06GetResource');
	if @pAisa06GetResource = nil then Exit;

	// Aisa06SetData ̃AhX擾
	pAisa06SetData := GetProcAddress(hDLL, 'Aisa06SetData');
	if @pAisa06SetData = nil then Exit;

	// Aisa06GetCH ̃AhX擾
	pAisa06GetCH := GetProcAddress(hDLL, 'Aisa06GetCH');
	if @pAisa06GetCH = nil then Exit;

	// Aisa06GetLastError ̃AhX擾
	pAisa06GetLastError := GetProcAddress(hDLL, 'Aisa06GetLastError');
	if @pAisa06GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

